require 'spec_helper'
require 'pry'

RSpec.describe 'configuration' do
  after do
    Ucb::Hcm.reset
  end

  describe '.configure' do
    Ucb::Hcm::Configuration::VALID_CONFIG_KEYS.each do |key|
      it "should set the #{key}" do
        Ucb::Hcm.configure do |config|
          config.send("#{key}=", key)
          expect(Ucb::Hcm.send(key)).to eq key
        end
      end
    end

    Ucb::Hcm::Configuration::VALID_CONFIG_KEYS.each do |key|
      describe ".#{key}" do
        it 'should return the default value' do
          if [:app_id, :app_key].include?(key)
            expect(Ucb::Hcm.send(key)).to be_nil
          else
            expect(Ucb::Hcm.send(key)).to eq Ucb::Hcm::Configuration.const_get("DEFAULT_#{key.upcase}")
          end
        end
      end
    end
  end
end