require 'spec_helper'
require 'pry'

describe 'request' do

  before do
    @client = Ucb::Hcm::Client.new(app_id: TestCredentials::TEST_APP_ID, app_key: TestCredentials::TEST_APP_KEY)
  end

  describe 'client' do
    it 'has a HTTParty client interface' do
      expect(@client.client).to eq HTTParty
    end
  end

  describe 'base endpoint' do
    it 'has a base endpoint the same as the configuration endpoint' do
      expect(@client.send(:base_endpoint)).to eq Ucb::Hcm::Configuration::DEFAULT_ENDPOINT
    end

    it 'can change the base end point' do
      new_endpoint = "hello"
      client = Ucb::Hcm::Client.new(app_id: TestCredentials::TEST_APP_ID, app_key: TestCredentials::TEST_APP_KEY, endpoint: new_endpoint)
      expect(client.send(:base_endpoint)).to eq new_endpoint
    end
  end

  describe 'get' do
    it 'performs a get request', :vcr do
      response = @client.get("/employees/10161331", {"id-type" => "hr-employee-id"})
      expect(response).to be_an_instance_of Ucb::Hcm::Response
      expect(response.success?).to eq true
    end
  end
end
